unit HostMainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, upfManager, StdCtrls, CustomIntf;

type
  // This is a descendent of the standard, default app services class.
  // We're merely adding support for the ICustomAppServices interface
  // we defined in CustomIntf.pas.
  TCustomAppServices = class(TupfStandardApplicationServices, ICustomAppServices)
     function GetValue : integer;
  end;

  TForm1 = class(TForm)
    upfPluginManager1: TupfPluginManager;
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{ TCustomAppServices }

function TCustomAppServices.GetValue: integer;
begin
   // return some value.
   Result := 42;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  upfPluginManager1.LoadPlugin('.\SamplePlugin1.bpl');
  ShowMessage('Sample plugin loaded');
end;

procedure TForm1.Button2Click(Sender: TObject);
var
   APlugin : ICustomPluginInfo;
begin
   if Supports(upfPluginManager1.Plugins[0], ICustomPluginInfo, APlugin) then
      APlugin.DoSomething;
end;

initialization
   RegisterClass(TCustomAppServices);

end.
