unit PluginOneU;


interface


uses

   Windows,

   Messages,

   SysUtils,

   Classes,

   Dialogs,

   Forms,

   upfIntf,

   sdiIntf,

   upfVisualClasses,

   Controls;


type


  TupfVisualPlugin1 = class(TupfVisualPlugin, ISDIPlugin)

  private

    { Private declarations }

  public

     function CreateModule(MainForm : TForm) : TFrame;

     procedure DestroyModule;
  end;


procedure Register;

procedure UnRegister;


implementation


uses FrameU;


var

  // CHANGE!

  // TupfVisualPlugin1 should be replaced with the name of your new

  // plugin type. For Example, TMyNewVisualPlugin.

   APlugin : TupfVisualPlugin1;


{$R *.DFM}


// IMPORTANT!

// Changes will be required here if you change the name of the visual

// plugin.

// These changes are marked below:

procedure Register;

var

  AppSvc : IupfCommandServices;

  SDISvc : ISDIServices;

  j      : integer;

begin

  // CHANGE!

  // TupfVisualPlugin1 should be replaced with the name of your new

  // plugin type. For Example, TMyNewVisualPlugin.

  APlugin := TupfVisualPlugin1.Create(nil);
  if assigned(ApplicationServices) then
  begin
    AppSvc := ApplicationServices as IupfCommandServices;
    AppSvc.RegisterPlugin(APlugin);
    for j := 0 to APlugin.Commands.Count - 1 do
      AppSvc.RegisterCommand(APlugin, APlugin.Commands[j]);
    SDISvc := ApplicationServices as ISDIServices;
    SDISvc.RegisterModule('Sample One', APlugin);
  end;
end;


procedure UnRegister;

begin

  // Free the plugin

  APlugin.Free;
end;


{ TupfVisualPlugin1 }

function TupfVisualPlugin1.CreateModule(MainForm: TForm): TFrame;
begin
   Result := TMyFrame.Create(MainForm);
   Result.Parent := MainForm;
   Result.Align := alClient;
end;

procedure TupfVisualPlugin1.DestroyModule;
begin

end;

end.